;------------------------------------------------------------------------
; 4CH IR REMOCON
; RECEIVER UNIT@M
; MCU   MicroChip PIC12F683
; CLOCK 4Mhz INTRC
;
; Version 1.00 2010.DEC.12@LEDdqH̑fiZp]_Ёj
;
; YS Design Studio 2000-2010 Copyright(C) 2010.
; URL htp://www5b.biglobe.ne.jp/~YASUSI
;------------------------------------------------------------------------
; 샂[h@I^l[g
; IR FORMAT NEC
;-----------------------------------------
; PIC12F683 PIN ASSIGN
;-----------------------------------------
;(8) GND
;(7) GPIO0	IR-REC DEVICE
;(6) GPIO1	PORT1 
;(5) GPIO2	PORT2 (PWM)
;(4) GPIO3	SWITCH	
;(3) GPIO4	PORT3	
;(2) GPIO5	PORT4	
;(1) VDD		
;------------------------------------------------------------------------

	list	p=12f683
	#include  <p12f683.inc>

	__CONFIG	_CP_OFF & _CPD_OFF & _WDT_OFF & _BOD_ON & _PWRTE_OFF & _INTRC_OSC_NOCLKOUT & _MCLRE_OFF

;---------------------------------------------------------------------------
; Define
;---------------------------------------------------------------------------
BIT		EQU	0x20	;
REC_CODE	EQU	0x21	; 
REC_DATA	EQU	0x22	;
REC_WORK	EQU	0x23	;

FLAG		EQU	0X26	;

WAIT1		EQU	0x2B	; 
WAIT2		EQU	0x2C	; 

#define	CUSTOMER_CODE01	0x33
#define	CUSTOMER_CODE02	0xCC

;---------------------------------------------------------------------------
; Power On vector
;---------------------------------------------------------------------------

	ORG	0x00
	goto	main

;===================================================================
;                               MAIN
;===================================================================
main	
	movlw	b'00000111'
	movwf	CMCON0 		; CMCON = CM0/CM1/CM2 ON (COMPARATOR OFF)
	
	bsf	STATUS,RP0	;

	movlw	B'00001001'	; 
	movwf	TRISIO		; Port I/O Set

	movlw	B'01100000'	; INT OSC 4Mhz 
	movwf	OSCCON		;

	movlw	B'00000000'	; AD-OFF 
	movwf	ANSEL

	bcf	STATUS,RP0	;

	clrf	GPIO		; CLEAR GPIO

	call	WAIT100MS

;-----------------------------------
; Main Loop 
;-----------------------------------
MAIN_LOOP

	btfsc	GPIO,0		; M`FbN
	goto	MAIN_LOOP

	call	IR_REC		; f[^M
	btfss	FLAG,0

	goto	NEXT

	call	WAIT50MS	; MG[͂TO҂
	goto	MAIN_LOOP

NEXT

	call	STANDARD_MODE	; X^_[h[h

	goto	MAIN_LOOP

;=============================================================================
;                                  MAIN END
;                             SUB ROUTINE START
;=============================================================================
;---------------------------------------------------------------------
; X^_[h[h
; I^l[gXCb`
;---------------------------------------------------------------------
STANDARD_MODE

	movlw	0x01		; 0x01
	xorwf	REC_DATA,W
	btfsc	STATUS,Z
	goto	STANDARD_PORT_ON

	movlw	0x02		; 0x02
	xorwf	REC_DATA,W
	btfsc	STATUS,Z
	goto	STANDARD_PORT_ON

	movlw	0x04		; 0x04
	xorwf	REC_DATA,W
	btfsc	STATUS,Z
	goto	STANDARD_PORT_ON

	movlw	0x08		; 0x08
	xorwf	REC_DATA,W
	btfsc	STATUS,Z
	goto	STANDARD_PORT_ON

	return			; R[h

STANDARD_PORT_ON
;|[gnm^neep^[e[u瓾
	movlw	0X00		; table̊JnAhX̏5bitPCLATH 
	movwf	PCLATH 

	movfw	REC_DATA
	call	OUTPUT_PATTERN
	movwf	REC_WORK	; vUޔ

;|[gɏo͂B
	btfsc	GPIO,3		; GPIO3 = HIGH dnmL 
	goto	MULTIPLEX_ON

;dnm֎~

	movfw	REC_WORK	
	xorwf	GPIO,W		; OƓXCb`̏ꍇ̓It@ȈꍇItɂ
	btfsc	STATUS,Z
	goto	ALL_CLEAR

	movfw	REC_WORK	; ̃|[g̏ꍇ̓I
	movwf	GPIO
	return

ALL_CLEAR
	clrf	GPIO		; I[It
	return

; dnm
MULTIPLEX_ON
	movfw	REC_WORK
	xorwf	GPIO,F		; ǉnm
	return

;------------------------------------
; OUTPUT PATTERN
;------------------------------------
OUTPUT_PATTERN

	andlw	0X0F
	addwf	PCL,F

	retlw	b'00000000'	; 0x10
	retlw	b'00000010'	; 0x11
	retlw	b'00000100'	; 0x12
	retlw	b'00000110'	; 0x13
	retlw	b'00010000'	; 0x14
	retlw	b'00010010'	; 0x15
	retlw	b'00010100'	; 0x16
	retlw	b'00010110'	; 0x17
	retlw	b'00100000'	; 0x18
	retlw	b'00100010'	; 0x19
	retlw	b'00100100'	; 0x1A
	retlw	b'00100110'	; 0x1B
	retlw	b'00110000'	; 0x1C
	retlw	b'00110010'	; 0x1D
	retlw	b'00110100'	; 0x1E
	retlw	b'00110110'	; 0x1F

;---------------------------------------------------------------------
; IR_REC
;---------------------------------------------------------------------
IR_REC
	bsf	FLAG,0		; SET ERROR FLAG

	call	READER_CHECK

	btfsc	FLAG,0		; REC ERROR FLAG1 = ON 
	return

	bsf	FLAG,0		; SET ERROR FLAG

	call	BYTE_REC	; CHECK CODE1 REC

	movlw	CUSTOMER_CODE01
	xorwf	REC_CODE,W
	btfss	STATUS,Z
	return

	call	BYTE_REC	; CHECK CODE2 REC

	movlw	CUSTOMER_CODE02
	xorwf	REC_CODE,W
	btfss	STATUS,Z
	return

	call	BYTE_REC	; DATA REC
	movfw	REC_CODE
	movwf	REC_DATA
		
	call	BYTE_REC	; REV DATA REC
	comf	REC_CODE,W
	xorwf	REC_DATA,W	; DATA CHECK
	btfsc	STATUS,Z
	bcf	FLAG,0		; CLEAR REC ERROR 

	return

;---------------------------------------------------------------------
; READER CHECK
;---------------------------------------------------------------------
READER_CHECK

;----------------------------------
; 9.0mS CHECK
; ̊ԂɐMHIGHɂȂƃG[
;----------------------------------
	movlw   0X09		; 0X09=8.728ms
	movwf   WAIT2		;

CHECK_9MS_LOOP1
	movlw   0XB9		; 0XC1
	movwf   WAIT1		;

CHECK_9MS_LOOP2

	btfsc	GPIO,0
	return			; ERROR RETURN 9mS LOW NG

	decfsz	WAIT1,F		;
	goto	CHECK_9MS_LOOP2

	decfsz	WAIT2,F		;
	goto	CHECK_9MS_LOOP1	;

;------------------------------------
; 9mS TO 4.5mS CHANGE CHECK 1000uS
; ̊ԂHIGHɐ؂ւ΂nj
;------------------------------------
	movlw	0XC8		; 0X64
	movwf	WAIT1		;
CHANGE_LOOP
	btfsc	GPIO,0		; btfss
	goto	CHECK_4MS	; TR DETECT

	decfsz	WAIT1,F		;
	goto	CHANGE_LOOP
	return			; ERROR RETURN TIME OVER 

;------------------------------------
; 4.5mS CHECK
; ̊ԂɐMLOWɂȂƃG[
;------------------------------------
CHECK_4MS
	movlw	0X04		; 0X04  4.253mS
	movwf	WAIT2		;

CHECK_4MS_LOOP1
	movlw	0XD3		; 0XD3
	movwf	WAIT1		;

CHECK_4MS_LOOP2
	btfss	GPIO,0		; btfss 
	return			; ERROR RETURN

	decfsz	WAIT1,F		;
	goto	CHECK_4MS_LOOP2

	decfsz	WAIT2,F		;
	goto	CHECK_4MS_LOOP1	;

;-------------------------------------
; 4.5mS END CHECK 1000uS
; ̊ԂɐMLOWɐ؂ւ΂nj
;-------------------------------------
	movlw	0XC8		; 0X64 500uS
	movwf	WAIT1		;
END_LOOP
	btfsc	GPIO,0		; btfsc
	goto	END_NEXT_LOOP

	bcf	FLAG,0		; ERROR FLAG CLEAR		
	return			; READER END

END_NEXT_LOOP

	decfsz	WAIT1,F		;
	goto	END_LOOP
	return			; ERROR RETURN
		
;--------------------------------------------------------
; BYTE_REC_1
;--------------------------------------------------------
BYTE_REC
	movlw	8
	movwf	BIT
	clrf	REC_CODE
		
BYTE_REC_LOOP
	btfss	GPIO,0    	; TR DETECT LOOP
	goto	$-1
	call	WAIT1MS		; TR DETECT
	
	bcf	STATUS,C
	btfsc	GPIO,0		; BIT 
	bsf	STATUS,C
	rlf	REC_CODE,F

	btfsc	GPIO,0		; TF ҂
	goto	$-1

	decfsz	BIT,F		; BIT shift
	goto	BYTE_REC_LOOP
	return


;-------------------------------------------------------
; WAIT100US
;-------------------------------------------------------
WAIT100US
	movlw	0X0A		;0X0A
	movwf	WAIT1		;
WAIT100US_LOOP
	goto	$+1
	goto	$+1
	goto	$+1
	nop
	decfsz	WAIT1,F		;
	goto	WAIT100US_LOOP
	return
;-------------------------------------------------------
; WAIT1MS
;-------------------------------------------------------
WAIT1MS
	movlw   0X64		;0X64
	movwf   WAIT1		;
WAIT1MS_LOOP
	goto	$+1
	goto	$+1
	goto	$+1
	nop
	decfsz	WAIT1,F		;
	goto	WAIT1MS_LOOP
	return
;-------------------------------------------------------
; WAIT50MS
;-------------------------------------------------------
WAIT50MS
	movlw	0X32		;0X32
	movwf	WAIT2		;
WAIT50MS_LOOP
	call	WAIT1MS
	decfsz	WAIT2,F		;
	goto	WAIT50MS_LOOP
	return
;-------------------------------------------------------
; WAIT100MS
;-------------------------------------------------------
WAIT100MS
	movlw	0X64		;0X64
	movwf	WAIT2		;
WAIT100MS_LOOP
	call	WAIT1MS
	decfsz	WAIT2,F		;
	goto	WAIT100MS_LOOP
	return

	END
