;------------------------------------------------------------------------
; 4CH 4-MODE IR REMOCON
; TRANSMITTER UNIT@M
; MCU   MicroChip PIC12F683
; CLOCK 4Mhz INTRC
;
; Version 1.00 2010.DEC.12@LEDdqH̑fiZp]_Ёj
;
; YS Design Studio 2000-2010 Copyright(C) 2010.
; URL htp://www5b.biglobe.ne.jp/~YASUSI
;------------------------------------------------------------------------
; 샂[h@I^l[g
; IR FORMAT NEC
;-----------------------------------------
; PIC12F683 PIN ASSIGN
;-----------------------------------------
;(8) GND	
;(7) GPIO0 IR-LED
;(6) GPIO1 SWITCH1 
;(5) GPIO2 SWITCH2
;(4) GPIO3 SWITCH3
;(3) GPIO4 SWITCH4
;(2) GPIO5 NC
;(1) VDD
;------------------------------------------------------------------------

	list	p=12f683
	#include  <p12f683.inc>

	__CONFIG	_CP_OFF & _CPD_OFF & _WDT_OFF & _BOD_OFF & _PWRTE_OFF & _INTRC_OSC_NOCLKOUT & _MCLRE_OFF

;---------------------------------------------------------------------------
; Define
;---------------------------------------------------------------------------
BIT		EQU	0x20	;
SEND_CODE	EQU	0x21	;
SEND_CMD	EQU	0x22	;
WAIT1		EQU	0x23	;
WAIT2		EQU	0x24	;
WAIT3		EQU	0x25	;

#define	SWITCH1		3
#define	SWITCH2		2
#define	SWITCH3		1
#define	SWITCH4		4
#define	SWITCH5		5

#define	CUSTOMER_CODE01	0x33
#define	CUSTOMER_CODE02	0xCC

;---------------------------------------------------------------------------
; Power On vector
;---------------------------------------------------------------------------

	ORG	0x00
	goto	MAIN

;===================================================================
;                               MAIN
;===================================================================
;----------------------------
; Initialize PIC12F683
;----------------------------
MAIN
	call	CAREER_ON
	movlw	b'00000111'
	movwf	CMCON0 		; CMCON = CM0/CM1/CM2 ON (COMPARATOR OFF)
	
	bsf	STATUS,RP0	;

	movlw	B'00111110'	; 
	movwf	TRISIO		; Port I/O Set

	movlw	b'00110110'	; SET PULL UP PIN (OUT)
	movwf	WPU			

	movlw	b'01111111'	; SET PULL UP PIN (IN)
	movwf	OPTION_REG

	movlw	b'00111110'	; SET INTERRUPT-ON-CHANGE PIN
	movwf	IOC

	movlw	B'01100000'	; INT OSC 4Mhz 
	movwf	OSCCON		;

	movlw	B'00000000'	; FOSC/32 AD-PIN ANS0 
	movwf	ANSEL

	bcf	STATUS,RP0	;

	clrf	GPIO		; Clear GPIO Port

	CALL	WAIT100MS	; WAIT

	bcf	INTCON,GPIF
	bsf	INTCON,GPIE


;-----------------------------------
; MAIN LOOP 
;-----------------------------------
MAIN_LOOP
	clrf	GPIO		; GPIO CLR
	movfw	GPIO		; GPIOWX^ǂݍ
	bcf	INTCON,GPIF

	sleep			; SLEEP

	call	WAIT50MS	; EH[~OAbv

	call	STANDARD_MODE

	goto	MAIN_LOOP

;=============================================================================
;                                  MAIN END
;                             SUB ROUTINE START
;=============================================================================
;---------------------------------------------------------------------
; W[h
;---------------------------------------------------------------------
STANDARD_MODE

STANDARD_SWITCH1
	btfsc	GPIO,SWITCH1		; SWITCH1 ON
	goto	STANDARD_SWITCH2

	movlw	0x01
	movwf	SEND_CMD
	call	SEND
	return
STANDARD_SWITCH2
	btfsc	GPIO,SWITCH2		; SWITCH2 ON
	goto	STANDARD_SWITCH3

	movlw	0x02
	movwf	SEND_CMD
	call	SEND
	return
STANDARD_SWITCH3
	btfsc	GPIO,SWITCH3		; SWITCH3 ON
	goto	STANDARD_SWITCH4

	movlw	0x04
	movwf	SEND_CMD
	call	SEND
	return
STANDARD_SWITCH4
	btfsc	GPIO,SWITCH4		; SWITCH4 ON
	return
	movlw	0x08
	movwf	SEND_CMD
	call	SEND
	return


;-------------------------------------
; IR SEND MAIN
;-------------------------------------
SEND
	call 	SEND_READER	; READER SEND

	movlw	CUSTOMER_CODE01	; CUSTOM CODE 1
	movwf	SEND_CODE
	call	SEND_BYTE

	movlw	CUSTOMER_CODE02	; CUSTOM CODE 2
	movwf	SEND_CODE
	call	SEND_BYTE

	movf	SEND_CMD,W	; DATA SEND
	movwf	SEND_CODE
	call	SEND_BYTE

	comf	SEND_CMD,W	; REVERSE DATA SEND
	movwf	SEND_CODE
	call	SEND_BYTE

	call	BIT0		; STOP BIT
	call	WAIT100MS	; WAIT

	return
;--------------------------------------------
; SEND READER NEC_FORMAT LOW=9mSHIGH4.5mS
;--------------------------------------------
SEND_READER			; 9.0mS 38KHz
	movlw   0XA4		; 0XA4 = 9.025mS
	movwf   WAIT1		;
READER_LOOP
	call	CAREER_ON
	call	CAREER_ON
	decfsz  WAIT1,F		;
	goto	READER_LOOP

				; 4.5mS LOW
	movlw   0XED		; 0XED = 4.508mS
	movwf   WAIT1		;

READER_LOOP1
	goto	$+1
	goto	$+1
	goto	$+1
	goto	$+1
	goto	$+1
	goto	$+1
	goto	$+1
	goto	$+1
	decfsz  WAIT1,F		;
	goto	READER_LOOP1
	return
;--------------------------------------------
; SEND BYTE
;--------------------------------------------
SEND_BYTE
	movlw	8
	movwf	BIT		;
BYTE_LOOP
	btfsc	SEND_CODE,7	;
	call	BIT1
	btfss	SEND_CODE,7
	call	BIT0
	rlf	SEND_CODE,F
	
	decfsz	BIT,F		;
	goto	BYTE_LOOP
	return

;--------------------------------------------
; BIT0 SEND
;--------------------------------------------
BIT0
	movlw   0X14		;0X14 = 585uS
	movwf   WAIT1		;
BIT0_LOOP
	call	CAREER_ON
	decfsz  WAIT1,F		;
	goto	BIT0_LOOP

	call	CAREER_OFF
	return
;--------------------------------------------
; BIT1 SEND
;--------------------------------------------
BIT1
	movlw   0X14		;0X14 = 585uS
	movwf   WAIT1		;
BIT1_LOOP
	call	CAREER_ON
	decfsz  WAIT1,F		;
	goto	BIT1_LOOP

	call	CAREER_OFF
	call	CAREER_OFF
	return

;--------------------------------------------
; CAREER 26uS ON
;--------------------------------------------
CAREER_ON_
	movlw	b'00000001'
	movwf	GPIO		;LED ON
	nop
	nop
	nop
	nop
	nop
	nop
	clrf	GPIO		;LED OFF
	goto	$+1
	goto	$+1
	goto	$+1
	goto	$+1
	goto	$+1
	goto	$+1
	nop
	return
;--------------------------------------------
; CAREER 26uS ON
;--------------------------------------------
CAREER_ON
	movlw	b'00000001'
	movwf	GPIO		;LED ON
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	clrf	GPIO		;LED OFF
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	return
;--------------------------------------------
; CAREER_OFF 588uS
;--------------------------------------------
CAREER_OFF
	movlw   0X35		;0X35 = 588uS
	movwf   WAIT2		;
CAREER_LOOP
	goto 	$+1
	goto 	$+1
	goto 	$+1
	goto 	$+1
	decfsz	WAIT2,F	;
	goto	CAREER_LOOP
	return


;-------------------------------------------------------
; WAIT1MS
;-------------------------------------------------------
WAIT1MS
	movlw   0X64		;0X64
	movwf   WAIT1		;

WAIT1MS_LOOP
	goto	$+1
	goto	$+1
	goto	$+1
	nop
	decfsz	WAIT1,F		;
	goto	WAIT1MS_LOOP
	return
;-------------------------------------------------------
; WAIT100MS
;-------------------------------------------------------
WAIT100MS
	movlw	0X64		;0X64
	movwf	WAIT2		;

WAIT100MS_LOOP
	call	WAIT1MS
	decfsz	WAIT2,F		;
	goto	WAIT100MS_LOOP
	return
;-------------------------------------------------------
; WAIT50MS
;-------------------------------------------------------
WAIT50MS
	movlw	0X32		;0X32
	movwf	WAIT2		;

WAIT50MS_LOOP
	call	WAIT1MS
	decfsz	WAIT2,F		;
	goto	WAIT50MS_LOOP
	return

	END
